const path = require('path');
const LOG = require('./utils/logger');
const CONSTANTS = module.exports

const dataNerdScope = '@datanerd'
const cliPackageName = 'newrelic-mobile-cli'
const rnAgentPackageName = "newrelic-mobile-rn"
const newRelicConfig = 'newrelic.json'
const newRelicAgentScriptsDir = path.join('node_modules', rnAgentPackageName, 'new-relic', 'scripts')

CONSTANTS.rnAgentPackageName = rnAgentPackageName
CONSTANTS.newRelicConfig = newRelicConfig

CONSTANTS.PATHS = {
  appBuildGradle: path.join('android', 'app', 'build.gradle'),
  androidAssestsDir: path.join('android', 'app', 'src', 'main', 'assets'),
  xcodePbxproj: path.join('ios', '*.xcodeproj', 'project.pbxproj'),
  rnApp: path.join('**', 'App.+(js|tsx|ts|jsx)'),
  sourceMapTmpJs: path.join('app', 'tmp', 'sourcemap-tmp.js'),
  tmpJs: path.join('app', 'tmp', 'tmp.js'),
  genSourceMapScript: path.join(newRelicAgentScriptsDir, 'js-sourcemap', 'rn-gen-source-map.sh'),
  iosPostBuildScript: path.join(newRelicAgentScriptsDir, 'dsym-upload-scripts', 'newrelic_postbuild.sh'),
}

CONSTANTS.IMPORT_LINES = {
  newRelicImport: `import NewRelic from '${rnAgentPackageName}';`,
  // This pathing is a safe-ish assumption. See app/frameworks/react-native/install.js:130
  applyNewRelicGradle: `apply from: "../../node_modules/${rnAgentPackageName}/newrelic.gradle"`
}

CONSTANTS.XCODE_BUILD_PHASES = {
  copyNewRelicJson: "New Relic - Copy newrelic.json into app bundle",
  uploadMaps: "New Relic - Upload source maps",
  postBuild: "New Relic - Post build"
}
