#!/usr/bin/env node
const program = require('commander');
const App = require('.');
const frameworks = require('./frameworks');
const platforms = require('./platforms');
const rnUpload = require('./frameworks/react-native/rn-upload')
const app = new App();
app.setup();

const verbose = {
  flags: '-v, --verbose',
  description: 'Log all the things!'
};

function getRNDefaults(cmd) {
  return {
    framework: frameworks.types.reactNative.name,
    platforms: [platforms.types.android.name, platforms.types.iOS.name],
    verbose: cmd.verbose
  }
};

program.version('0.0.01');

program
.command('setup') // sub-command name
.option(verbose.flags, verbose.description)
.action(function (cmd) {
  app.handleProgram(getRNDefaults(cmd))
});

program
.command('remove') // sub-command name
.option(verbose.flags, verbose.description)
.action(function (cmd) {
  app.handleProgram(getRNDefaults(cmd))
});

program
.command('rn-upload')
.option(verbose.flags, verbose.description)
.action(function (cmd) {
  rnUpload.upload(cmd)
});

program.parse(process.argv);

