const LOG = require('../utils/logger')

const SERVICE_HELPER = module.exports

SERVICE_HELPER.environments = {
  na: 'https://mobile-symbol-upload.newrelic.com',
  eu: (region) => `https://mobile-symbol-upload.${region}.nr-data.net`,
  staging: 'https://staging-mobile-symbol-upload.newrelic.com'
}

SERVICE_HELPER.hasRegion = (token) => {
  const match = token.match(/^.*?x/)
  return match && match.length > 0
}

SERVICE_HELPER.getRegion = (token) => {
  LOG.debug(`parsing token: ${token}`)
  return token.match(token)[0].replace('x', '')
}

SERVICE_HELPER.getEnvironmentsUrl = (token, staging) => {
  const {environments} = SERVICE_HELPER
  let url = environments.na

  if (staging) {
    LOG.debug('staging env detected')
    url = environments.staging
  }

  if (SERVICE_HELPER.hasRegion(token)) {
    LOG.debug('Region env detected')
    url = environments.eu(SERVICE_HELPER.getRegion(token))
  }

  return url
}
