const _topics = {}
let _subId = -1;

class PubSub {
  constructor() {
    _subId = -1
  }

  publish(topic, args) {
    if (!_topics[topic]) {
      return false;
    }

    const subscribers = _topics[topic]
    let len = subscribers ? subscribers.length : 0;

    while (len--) {
      subscribers[len].action(args);
    }

    return this;
  }

  subscribe(topic, action) {

    if (!_topics[topic]) {
      _topics[topic] = [];
    }

    const token = (++_subId).toString();

    _topics[topic].push({
      token,
      action,
    });

    return token;
  };

}

const PUB_SUB = new PubSub()

module.exports = PUB_SUB
